#!/bin/bash

USAGE="Usage: `basename $0` [-g] [-c] [-p prefix ]
   -p: install prefix = /vol/xcf
   -g: debug mode
   -c: maintainer-clean"

prefix=/vol/xcf
CONFIG_ARGS=
# Parse command line options.
while true ; do
    case "$1" in
       -g)  DEBUG="--enable-debug"
            ;;
       -c)  clean=1
            ;;
       -p)  prefix=$2; shift
            ;;
       -h)  echo $USAGE
            exit 0
            ;;
       "")  break
            ;;
        *)  # unknown option
            echo "unknown option '$1': handed over to config script"
            CONFIG_ARGS="$CONFIG_ARGS $1"
            ;;
    esac
    shift
done

srcdir=`dirname $0`

if [ -n "$clean" ] ; then
   echo "cleaning"
   make maintainer-clean
fi

if [ ! -f $srcdir/configure ] || [ $srcdir/configure -ot $srcdir/configure.ac ] ; then
   pushd $srcdir; ./bootstrap.sh; popd
fi

cmd="$srcdir/configure --prefix=$prefix $CONFIG_ARGS"
echo $cmd
eval $cmd
make -j4
make check
