dnl AC_TRY_LIB_IN(library, prefix, includes, function-body, [ACTION-IF-FOUND], [ACTION-IF-NOT-FOUND]])
AC_DEFUN([AC_TRY_LIB_IN], 
[AC_MSG_CHECKING([for lib$1])
dnl
define([LIB_PATH], translit($1, `a-z0-9-', `A-Z0-9')_PATH)
define([LIB_CPPFLAGS], translit($1, `a-z0-9-', `A-Z0-9')_CPPFLAGS)
define([LIB_LDFLAGS], translit($1, `a-z0-9-', `A-Z0-9')_LDFLAGS)
define([LIB_LIBS], translit($1, `a-z0-9-', `A-Z0-9')_LIBS)

AC_ARG_VAR(LIB_PATH, [root directory of $1])
AC_ARG_VAR(LIB_CPPFLAGS, [C compiler flags for $1])
AC_ARG_VAR(LIB_LDFLAGS, [linker flags for $1])
AC_ARG_VAR(LIB_LIBS, [libs needed for $1])

AC_ARG_WITH($1,[AS_HELP_STRING([--with-$1=dir],
               [installation prefix for $1 (default: $prefix $2)])], 
            LIB_PATH="$withval")

# check wether configuration works
found=0
ac_save_CPPFLAGS="$CPPFLAGS"
ac_save_LDFLAGS="$LDFLAGS"
ac_save_LIBS="$LIBS"
for pfx in NONE $LIB_PATH $prefix $2
do
	LIB_CPPFLAGS="-I$pfx/include"
	LIB_LDFLAGS="-L$pfx/lib"
	LIB_LIBS="-l$1"
	CPPFLAGS="$LIB_CPPFLAGS $ac_save_CPPFLAGS"
	LDFLAGS="$LIB_LDFLAGS $ac_save_LDFLAGS"
	LIBS="$LIB_LIBS $ac_save_LIBS"

	AC_LINK_IFELSE([AC_LANG_PROGRAM([[$3]],[[$4]])], found=1)
	
	if test "$found" = "1"
	then
		if test "$pfx" = "NONE" -a -n "$LIB_PATH" ; then continue; fi
		break
	fi
done
CPPFLAGS="$[ac_save_CPPFLAGS]"
LDFLAGS="$[ac_save_LDFLAGS]"
LIBS="$[ac_save_LIBS]"

if test "$found" = "1"
then
   if test "$pfx" = "NONE"; then 
      # the test worked out, but with the already existing variables
      unset pfx
      LIB_CPPFLAGS=$CPPFLAGS
      LIB_LDFLAGS=$LDFLAGS
	else
		LIB_LDFLAGS="$LIB_LDFLAGS " # -Wl,-rpath -Wl,$pfx/lib"
   fi
	AC_MSG_RESULT([yes: $pfx])
   LIB_PATH=$pfx
   ifelse($5, [], [
     ac_tr_lib=HAVE_LIB$(echo "$1"| tr a-z- A-Z_)
     AC_DEFINE_UNQUOTED($ac_tr_lib)
	  AC_SUBST(LIB_CPPFLAGS)
	  AC_SUBST(LIB_LDFLAGS)
	  AC_SUBST(LIB_LIBS)
     ], $5)
else
	unset LIB_CPPFLAGS
	unset LIB_LDFLAGS
	unset LIB_LIBS
	AC_MSG_RESULT([no. Tried in: $LIB_PATH $prefix $2])
	$6
fi
unset found

undefine([LIB_LIBS])
undefine([LIB_LDFLAGS])
undefine([LIB_CPPFLAGS])
undefine([LIB_PATH])
])


dnl Locate a program and check that its version is acceptable.
dnl AC_PROG_CHECK_VER(var, namelist, version-switch,
dnl 		      [version-extract-regexp], version-glob [, do-if-fail])
AC_DEFUN([AC_CHECK_PROG_VER],
[AC_CHECK_PROGS([$1], [$2])
if test -z "[$]$1"; then
  ac_verc_fail=yes
else
  # Found it, now check the version.
  AC_MSG_CHECKING([version of [$]$1])
changequote(<<,>>)dnl
  ac_prog_version=`<<$>>$1 $3 2>&1 ifelse(<<$4>>,,,
                   <<| sed -n 's/^.*patsubst(<<$4>>,/,\/).*$/\1/p'>>)`
  case $ac_prog_version in
    '') ac_prog_version="v. ?.??, bad"; ac_verc_fail=yes;;
    <<$5>>)
changequote([,])dnl
       ac_prog_version="$ac_prog_version, ok"; ac_verc_fail=no;;
    *) ac_prog_version="$ac_prog_version, bad"; ac_verc_fail=yes;;

  esac
  AC_MSG_RESULT([$ac_prog_version])
fi
ifelse([$6],,,
[if test $ac_verc_fail = yes; then
  $6
fi])
])
