#include "XOPExampleData.hpp"

#include <fstream>
#include <iostream>

using namespace std;

namespace xmltio
{

XOPExampleData::XOPExampleData()
{
	std::string doc;

	try {
		// read XML file
		ifstream in("XOPObject.xml", ios::in);
		if (!in) cerr << "can't open file: XOPObject.xml" << endl;

		char ch;
		while (in.get(ch)) {
			doc+=ch;
		}
		in.close();
		setDocument(doc);

		XOPAttachmentPtr lena(new XOPAttachment());

		// read binary file
		in.open("lena.jpg",ios::binary);
		if (!in) cerr << "can't open file: lena.jpg" << endl;

		while (in.get(ch)) {
			lena->push_back((unsigned char) ch);
		}
		in.close();
		setContentWithId("lena.jpg",lena);

	} catch (std::exception& ex) {
		cerr << ex.what() << endl;
	}
}

XOPExampleData::~XOPExampleData()
{
}

string XOPExampleData::getDocument() {
	return doc_;
}

void XOPExampleData::setDocument(string doc) {
	doc_ = doc;
}

void XOPExampleData::setContentWithId(std::string cId, XOPAttachmentPtr xopAttachment) {
	packages_[cId]=xopAttachment;
}

XOPAttachmentPtr XOPExampleData::getContentWithId(std::string cId) {
	return packages_[cId];
}

}
