#ifndef XOPEXAMPLEDATA_HPP_
#define XOPEXAMPLEDATA_HPP_

#include <string>
#include <vector>
#include <map>
#include <boost/shared_ptr.hpp>

namespace xmltio
{

typedef std::vector<unsigned char> XOPAttachment;
typedef boost::shared_ptr<XOPAttachment> XOPAttachmentPtr;

class XOPExampleData
{
private:
	std::string doc_;
	std::map<std::string, XOPAttachmentPtr> packages_;

public:
	XOPExampleData();
	virtual ~XOPExampleData();

	std::string getDocument();
	void setDocument(std::string doc);
	void setContentWithId(std::string cId, XOPAttachmentPtr xopAttachment);
	XOPAttachmentPtr getContentWithId(std::string cId);
};

typedef boost::shared_ptr<XOPExampleData> XOPExampleDataPtr;

}

#endif /*XOPEXAMPLEDATA_HPP_*/
