/* -*- mode: C++; tab-width: 8; c-basic-offset: 8; c-file-offsets: ((substatement-open . 0)) -*- */
/**
 *
 * @file	Namespaces.hpp
 * @author	Ingo Luetkebohle (iluetkeb@TechFak.Uni-Bielefeld.de)
 * @date	started at 2004/10/07
 * @version	$Id: Namespaces.hpp 4251 2015-01-14 21:35:25Z rhaschke $
 *
 **/

#ifndef __XMLTIO_NAMESPACES_HPP
#define __XMLTIO_NAMESPACES_HPP

#include "exception.hpp"

#include <xercesc/dom/DOMElement.hpp>
#include <xercesc/dom/DOMNamedNodeMap.hpp>

#include <string>
#include <map>
#include <iosfwd>

namespace xmltio {
class XercesDocumentBody;

/** \brief Namespace management
 *
 **/
class XMLTIO_API Namespaces {
protected:
	/// document element
	XERCES_CPP_NAMESPACE::DOMElement* de_;

	// \brief construct from node whose attributes are to
	// be modified.
	Namespaces(XERCES_CPP_NAMESPACE::DOMElement* de);
public:
	void put(const std::string& prefix, const std::string& uri);
	void remove(const std::string& prefix);
	void merge(const Namespaces&);

	friend class XercesDocumentBody;
};
}

#endif //  __XMLTIO_NAMESPACES_HPP
